package edu.hust.go.term;

/**
 * <p>Title: GO4J</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author GQ Zhang
 * @version 1.0
 */

import java.util.*;

/**
 * the OBOGo_term is designed for OBO flat file format version 1.2
 * (http://www.godatabase.org/dev/doc/obo_format_spec.html)
 * 
 * @author Admin
 */
public class OBOGo_term extends DefaultGO_term {
	// id
	// name
	boolean is_anonymous = false;

	Vector<String> alt_id;

	// def
	String comment;

	Vector<String> subset;

	Vector<String> synonym;

	Vector<String> exact_synonym;

	Vector<String> narrow_synonym;

	Vector<String> broad_synonym;

	Vector<String> xref;

	Vector<String> xref_analog;

	Vector<String> xref_unk;

	// is_a

	Vector<String> intersection_of;

	Vector<String> union_of;

	Vector<String> disjoint_from;

	Vector<String> relationship;

	boolean is_obsolete;

	Vector<String> replaced_by;

	Vector<String> consider;

	Vector<String> use_term;

	boolean builtin;

	/*public OBOGo_term(HashMap<String, Vector<String>> map) {
		this("[0-9]+", "GO", ":",map);		
	}*/
	
	public OBOGo_term(String _idPatternStr, String _idPrefixStr, String _connectStr,HashMap<String, Vector<String>> map) {
		super(_idPatternStr, _idPrefixStr, _connectStr);
		id = this.setId(setStr(map, "id"));
		name = setStr(map, "name");
		is_anonymous = setBool(map, "is_anonymous");
		alt_id = map.get("alt_id");
		def = setStr(map, "def");
		comment = setStr(map, "comment");
		subset = map.get("subset");
		synonym = map.get("synonym");
		exact_synonym = map.get("exact_synonym");
		narrow_synonym = map.get("narrow_synonym");
		broad_synonym = map.get("broad_synonym");
		xref = map.get("xref");
		xref_analog = map.get("xref_analog");
		xref_unk = map.get("xref_unk");
		is_a = map.get("is_a");
		intersection_of = map.get("intersection_of");
		union_of = map.get("union_of");
		disjoint_from = map.get("disjoint_from");
		relationship = map.get("relationship");
		is_obsolete = setBool(map, "is_obsolete");
		replaced_by = map.get("replaced_by");
		consider = map.get("consider");
		use_term = map.get("use_term");
		builtin = setBool(map, "builtin");

		is_a = setId(is_a);
		part_of = setId(relationship);
	}

	private String setStr(HashMap<String, Vector<String>> map, String key) {
		Vector<String> vector = map.get(key);
		if (vector != null && vector.size() > 0) {
			return vector.get(0);
		}
		return NULL_STRING;
	}

	boolean setBool(HashMap<String, Vector<String>> map, String key) {
		Vector<String> vector = map.get(key);
		String str = NULL_STRING;
		if (vector != null && vector.size() > 0) {
			str = vector.get(0);
		}
		if (str.equals(NULL_STRING))
			return false;
		else
			return str.equals("true") || str.equals("yes") || str.equals("1");
	}

	public Vector<String> getAlt_id() {
		return alt_id;
	}

	public Vector<String> getBroad_synonym() {
		return broad_synonym;
	}

	public boolean isBuiltin() {
		return builtin;
	}

	public String getComment() {
		return comment;
	}

	public Vector<String> getConsider() {
		return consider;
	}

	public Vector<String> getDisjoint_from() {
		return disjoint_from;
	}

	public Vector<String> getExact_synonym() {
		return exact_synonym;
	}

	public Vector<String> getIntersection_of() {
		return intersection_of;
	}

	public boolean isIs_anonymous() {
		return is_anonymous;
	}

	public boolean isIs_obsolete() {
		return is_obsolete;
	}

	public Vector<String> getNarrow_synonym() {
		return narrow_synonym;
	}

	public Vector<String> getRelationship() {
		return relationship;
	}

	public Vector<String> getReplaced_by() {
		return replaced_by;
	}

	public Vector<String> getSubset() {
		return subset;
	}

	public Vector<String> getSynonym() {
		return synonym;
	}

	public Vector<String> getUnion_of() {
		return union_of;
	}

	public Vector<String> getUse_term() {
		return use_term;
	}

	public Vector<String> getXref() {
		return xref;
	}

	public Vector<String> getXref_analog() {
		return xref_analog;
	}

	public Vector<String> getXref_unk() {
		return xref_unk;
	}
}
